/*
 * usermode +D: makes it so you cannot receive non-channel privmsgs
 * except from opers, U-lines and servers.
 * Just an example of msghooks :P. -- Syzop
 */

#include "config.h"
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include <time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef _WIN32
#include <io.h>
#endif
#include <fcntl.h>
#include "h.h"
#ifdef STRIPBADWORDS
#include "badwords.h"
#endif
#ifdef _WIN32
#include "version.h"
#endif

#ifndef DYNAMIC_LINKING
ModuleHeader m_privdeaf_Header
#else
#define m_privdeaf_Header Mod_Header
ModuleHeader Mod_Header
#endif
  = {
	"m_privdeaf",	/* Name of module */
	"v0.0.2", /* Version */
	"private messages deaf (+D)", /* Short description of module */
	"3.2-b8-1",
	NULL 
    };

long UMODE_PRIVDEAF = 0;

ModuleInfo PrivdeafModInfo;

static Hook *CheckMsg;

DLLFUNC char *privdeaf_checkmsg(aClient *, aClient *, aClient *, char *, int);

/* The purpose of these ifdefs, are that we can "static" link the ircd if we
 * want to
*/

/* This is called on module init, before Server Ready */
#ifdef DYNAMIC_LINKING
DLLFUNC int	Mod_Init(ModuleInfo *modinfo)
#else
int    m_privdeaf_Init(ModuleInfo *modinfo)
#endif
{
	/* Add the umode */
	UMODE_PRIVDEAF = umode_gget('D');
	/* TODO: test if umode_gget failed? */
	
	/* Hooking */
	bcopy(modinfo,&PrivdeafModInfo,modinfo->size);
	CheckMsg = HookAddPCharEx(PrivdeafModInfo.handle, HOOKTYPE_USERMSG, privdeaf_checkmsg);
}

/* Is first run when server is 100% ready */
#ifdef DYNAMIC_LINKING
DLLFUNC int	Mod_Load(int module_load)
#else
int    m_privdeaf_Load(int module_load)
#endif
{
}


/* Called when module is unloaded */
#ifdef DYNAMIC_LINKING
DLLFUNC int	Mod_Unload(int module_unload)
#else
int	m_privdeaf_Unload(int module_unload)
#endif
{
	/* Remove umode :( */
	umode_delete('D', UMODE_PRIVDEAF);
	UMODE_PRIVDEAF = 0;
	/* And tha hook :/ */
	HookDel(CheckMsg);
}

DLLFUNC char *privdeaf_checkmsg(aClient *cptr, aClient *sptr, aClient *acptr, char *text, int notice)
{
	if ((acptr->umodes & UMODE_PRIVDEAF) && !IsAnOper(sptr) && !IsULine(sptr) && !IsServer(sptr))
		return NULL; /* Silently ignored >:) */
	else
		return text;
}
